# Este scripti foi desenvolvido em língua portuguesa
# como forma de auxiliar colegas da área de LC.
#Este Script se baseia no pacote tidytext. 
# Contato: Rodrigo Esteves de Lima-Lopes
# rll307@unicamp.br
#Outros scripts: http://www.iel.unicamp.br
#Tutorial baseado em 

writeLines(
  "Este script foi desenvolvido em língua portuguesa
  como forma de auxiliar colegas da área de LC.
  Este Script se baseia no pacote tidytext
  Contato: Rodrigo Esteves de Lima-Lopes
  rll307@unicamp.br
  Outros scripts: http://www.iel.unicamp.br")



#iniciando as bibliotecas
library(tidytext)
library(dplyr)
library(readr)
library(tidyverse)
library(tm)
library(tidyr)
library(scales)

#importanto arquivos e definindo stopwords

#Definindo as stopwords
stopwords = read_csv("stop_port2.csv")

#importando os arquivos dos dois livros
estrela <- readLines("estrelab.txt")
estrela <- data.frame(text = estrela, stringsAsFactors = F)
estrela.tidy <- estrela %>%
  unnest_tokens(word, text)%>%
  anti_join(stopwords)


paixao <- readLines("paixaob.txt")
paixao <- data.frame(text = paixao, stringsAsFactors = F)
paixao.tidy <- paixao %>%
  unnest_tokens(word, text)%>%
  anti_join(stopwords)

#uma prévia das palavras
paixao.l<- paixao.tidy%>%
  count(word, sort = TRUE)
esterla.l <- estrela.tidy%>%
  count(word, sort = TRUE)

#montando uma tabela com os dados


frequencia.clarisse <- bind_rows(mutate(paixao.tidy, livro = "P"),
                                 mutate(estrela.tidy, livro = "H")) %>%
  mutate(word = str_extract(word, "[a-z']+")) %>%
  count(livro, word) %>%
  group_by(livro) %>%
  mutate(proportion = n / sum(n)) %>%
  select(-n) %>%
  spread(livro, proportion)


#criando o gráfico

ggplot(frequencia.clarisse, aes(x = H, y = P,
                                color = abs(H - P))) +
  geom_abline(color = "gray40", lty = 2) +
  geom_jitter(alpha = 0.1, size = 2.5, width = 0.3, height = 0.3) + 
  geom_text(aes(label = word), check_overlap = TRUE, vjust = 1.5) + 
  scale_x_log10(labels = percent_format()) +
  scale_y_log10(labels = percent_format()) + 
  scale_color_gradient(limits = c(0, 0.001),
                       low = "darkslategray4", high = "gray75") +
  theme(legend.position="none") + 
  labs(y = "Paixão segundo GH", x = "Hora da Estrela")
